﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class final1 : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Users_LdapUsers_LdapUserId",
                table: "Users");

            migrationBuilder.DropIndex(
                name: "IX_Users_LdapUserId",
                table: "Users");

            migrationBuilder.DropColumn(
                name: "LdapUserId",
                table: "Users");

            migrationBuilder.DropTable(
                name: "LdapUsers");

            migrationBuilder.CreateTable(
                name: "ExternalUsers",
                columns: table => new
                {
                    ExternalId = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Email = table.Column<string>(nullable: true),
                    FirstName = table.Column<string>(nullable: true),
                    LastName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    NeedToRefreshData = table.Column<bool>(nullable: false),
                    Token = table.Column<string>(nullable: true),
                    UserId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExternalUsers", x => x.ExternalId);
                    table.ForeignKey(
                        name: "FK_ExternalUsers_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.AddColumn<bool>(
                name: "CanChangeUserData",
                table: "SystemRolePermissions",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<string>(
                name: "HtmlColor",
                table: "Tags",
                nullable: true);

            migrationBuilder.AddColumn<string>(
                name: "HtmlIcon",
                table: "Tags",
                nullable: true);

            migrationBuilder.AddColumn<bool>(
                name: "RunAlsoNormalTests",
                table: "ExerciseReleases",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AddColumn<bool>(
                name: "ShouldAutomaticAssessSubmissions",
                table: "ExerciseReleases",
                nullable: false,
                defaultValue: false);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Tags",
                nullable: false);

            migrationBuilder.AddUniqueConstraint(
                name: "Unique_Tag",
                table: "Tags",
                column: "DisplayName");

            migrationBuilder.CreateIndex(
                name: "IX_ExternalUsers_UserId",
                table: "ExternalUsers",
                column: "UserId",
                unique: true);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropUniqueConstraint(
                name: "Unique_Tag",
                table: "Tags");

            migrationBuilder.DropColumn(
                name: "CanChangeUserData",
                table: "SystemRolePermissions");

            migrationBuilder.DropColumn(
                name: "HtmlColor",
                table: "Tags");

            migrationBuilder.DropColumn(
                name: "HtmlIcon",
                table: "Tags");

            migrationBuilder.DropColumn(
                name: "RunAlsoNormalTests",
                table: "ExerciseReleases");

            migrationBuilder.DropColumn(
                name: "ShouldAutomaticAssessSubmissions",
                table: "ExerciseReleases");

            migrationBuilder.DropTable(
                name: "ExternalUsers");

            migrationBuilder.CreateTable(
                name: "LdapUsers",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_LdapUsers", x => x.Id);
                });

            migrationBuilder.AddColumn<int>(
                name: "LdapUserId",
                table: "Users",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_Users_LdapUserId",
                table: "Users",
                column: "LdapUserId",
                unique: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Tags",
                nullable: true);

            migrationBuilder.AddForeignKey(
                name: "FK_Users_LdapUsers_LdapUserId",
                table: "Users",
                column: "LdapUserId",
                principalTable: "LdapUsers",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
