﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using ClientServer.Db;

namespace ClientServer.Models.Users
{
    /// <summary>
    /// a system role for a user
    /// </summary>
    public class SystemRole
    {
        public int Id { get; set; }
        /// <summary>
        /// the name of the role
        /// </summary>
        [MaxLength(YapexDbContext.DefaultMaxStringLength)]
        public string DisplayName { get; set; }

        /// <summary>
        /// the email of the role (may be null)
        /// </summary>
        [MaxLength(YapexDbContext.DefaultMaxStringLength)]
        public string Email { get; set; }



        public int SystemRolePermissionId { get; set; }
        /// <summary>
        /// the connected <see cref="SystemRolePermission"/>
        /// </summary>
        public SystemRolePermission SystemRolePermission { get; set; }
    }
}
